# Summary

[版本修订记录](./changelog.md)

- [前言](./preface.md)
- [项目组织结构](./project-structure/project-structure.md)
  - [各种文件的功能](./project-structure/file-categories.md)
  - [代码文件的组织](./project-structure/project-organize.md)
- [源码文件结构](./source-structure.md)
- [预处理指令](./preprocess-cmds.md)
- [命名空间](./namespace.md)
- [内置数据类型](./simple-types/data-types.md)
  - [变量定义](./simple-types/define-vars.md)
  - [常量定义](./simple-types/define-constants.md)
  - [基本数据类型](./simple-types/basic-types.md)
  - [数组](./simple-types/arrays.md)
  - [字符串](./simple-types/strings.md)
  - [类型转换](./simple-types/type-conversion.md)
- [复杂数据类型](./complex-types/complex-types.md)
  - [结构](./complex-types/structures.md)
  - [联合](./complex-types/unions.md)
  - [枚举](./complex-types/enumerates.md)
  - [类型别名](./complex-types/aliasing.md)
- [操作符](./operators.md)
- [控制结构](./control-structure/control-structure.md)
  - [分支语句](./control-structure/conditions.md)
  - [循环语句](./control-structure/loops.md)
- [函数定义](./functions/define-functions.md)
  - [形参与实参](./functions/parameters.md)
  - [参数默认值](./functions/default-arguments.md)
  - [Lambda 表达式](./functions/lambda.md)
  - [内联函数](./functions/inline-functions.md)
- [指针操作](./pointers/pointers.md)
  - [指针变量的声明](./pointers/declaration.md)
  - [指针的使用](./pointers/usage.md)
  - [指针的运算](./pointers/computation.md)
  - [指针与数组](./pointers/arrays.md)
  - [指针的指针](./pointers/point-to-pointer.md)
  - [利用指针构建复杂数据结构](./pointers/complex-structure.md)
  - [指针做为函数参数和返回值](./pointers/pointer-as-return.md)
  - [函数指针](./pointers/function-pointer.md)
- [引用](./references/reference.md)
  - [引用做为函数参数和返回值](./references/reference-as-return.md)
- [内存空间的分配与释放](./allocation.md)
- [关于类](./classes/about-class.md)
  - [类的声明格式](./classes/declaration.md)
  - [成员函数定义](./classes/member.md)
  - [构造函数与析构函数](./classes/construct.md)
  - [继承](./classes/inheritance.md)
  - [重载操作符](./classes/override-operator.md)
  - [创建实例](./classes/create-instance.md)
  - [友元](./classes/friend.md)
- [异常处理](./exceptions.md)
- [`const`的使用](./usage-const.md)
- [泛型](./generic/about-generic.md)
  - [函数模板](./generic/generic-functions.md)
  - [类模板](./generic/generic-class.md)
  - [非类型模板形参](./generic/value-template.md)
- [文件操作](./io/about-io.md)
  - [标准输入输出](./io/standard-io.md)
  - [文件处理](./io/file.md)
- [常用数据结构](./data-structures/glance.md)
  - [容器类](./data-structures/containers.md)
  - [`std::size_t`](./data-structures/size_t.md)
  - [智能指针](./data-structures/smart-ptr.md)
- [常用库](./libraries/about-libraries.md)
  - [如何将库加入项目依赖](./libraries/add-dependencies.md)
  - [标准库](./libraries/standard-library.md)
- [makefile 编制](./makefile/makefile.md)
  - [条目规则](./makefile/items.md)
  - [变量](./makefile/variables.md)
- [CMake 配置](./cmake/about-camke.md)
  - [基本配置](./cmake/basic-config.md)
  - [添加多个源码文件](./cmake/add-sources.md)
  - [设定输出目录](./cmake/set-output.md)
  - [将子目录内容编译为链接库](./cmake/subdir-as-library.md)
  - [自定义变量](./cmake/custom-variables.md)
  - [添加第三方库](./cmake/add-libraries.md)
- [项目编译](./compile/about-compiler.md)
  - [动态链接库和静态链接库](./compile/libraries.md)
  - [g++常用命令行格式](./compile/gpp.md)
  - [使用 CMake 完成项目编译](./compile/use-cmake.md)
- [C++11 新特性](./nf-cpp11.md)
- [C++14 新特性](./nf-cpp14.md)
