# 类的声明格式

类使用`class`关键字声明，基本声明格式如下：

```c++
class 类名称 {
    private:
        // 私有成员声明
    public:
        // 公有成员声明
}
```

C++中的类的私有声明和公有声明的顺序没有限制。当私有声明在前时，`private`关键字可以省略，因为 C++的类中成员默认都是私有的。

> C++中的结构也可以实现类的功能，但其中的成员默认都是公有的。

以下给出一个复杂的类定义，其中包含了一个带有继承的类应该有的大部分声明。

```c++
class Vehicle {
    public:
        virtual void build() {} // 虚函数可以被子类重新定义
        void run()=0; // 这里指出这个类是一个抽象类，这个成员为纯虚函数
    protected:
        double length;
        double width;
        double height;
}

class Car: public Vehicle { // 继承Vehicle类
    public:
        Car(); // 构造函数
        ~Car(); // 析构函数
    private:
        std::string brand;
        std:string name;
        int wheels;
        int seats;
}
```
