# 成员函数定义

实现成员函数不需要再遵循类的声明的格式，只需要在源代码文件中使用`返回值类型 类名称::成员函数名(参数列表) {}`的格式完成实现即可。例如上节中的`Car`类的成员函数即可使用`void Car::build() {}`来完成实现。

成员函数中可以使用`this`指针来访问自身对象。这里有一个小技巧，成员函数在返回`class&`类型时，返回`*this`即可实现连续操作，例如：`new Builder()->setName(0)->build()`。这种成员函数可以这样定义。

```c++
Builder& setName(int value) {
    this->value = value;
    return *this;
}
```
