# 函数定义

函数是由一组语句组合在一起执行固定功能的语句体，每个 C++程序都至少有一个函数——`main()`。声明一个函数需要三个元素：函数的返回值、函数名称和参数列表，完成函数定义需要一个语句体。

函数在不同的位置会有不同的称呼，例如在类中可能会称为成员函数或者方法。也有书籍中称呼函数为方法、子例程等。

声明并定义函数的格式如下：

```c++
// 函数的声明
返回值类型 函数名称(参数列表);
// 函数的完整定义
返回值类型 函数名称(参数列表) {
    函数语句体;
    return 返回值表达式;
}
```

函数的返回值类型和参数列表被称为函数签名，函数签名相同的函数会被认为是同一个函数。函数签名不同的函数即便是函数名称相同，也可以同时存在，这种特性称为函数重载。函数在声明时，参数列表中可以仅书写每个参数的类型，不必声明参数名称，但是函数在定义时必须给定参数名称。

```admonish tip
使用带有默认值的参数可以在一定程度上替代函数重载。
```

函数通过函数名称来调用，格式为`函数名称(参数列表)`。

如果一个函数不必返回任何值，需要将其返回值类型设置为`void`类型。
