# 形参与实参

函数在声明时，参数列表中的参数被称为形式参数，简称形参。形参在函数体中可以像局部变量一样使用。在函数调用时，列举在参数列表中用于向函数传递值的参数被称为实际参数，简称实参。

C++通常按值传递参数，即将一个数值参数传递给函数，函数会将其赋给一个新的变量。

函数可以接受一个数组作为参数，但是需要注意的是，这时向函数传递的不是数组本身，而是数组作为一个指针传递进了函数。例如`int sum(int arr[])`和`int sum(int *arr)`的含义是相同的。为了防止函数对传入的内容作出修改，保护传入的内存区域，一般会使用`int sum(const int arr[])`的方式来定义只读参数。

对于其他数据类型，当其占用内存空间较小时，使用按值传递的方式比较合理。但是无论在任何情况下，使用指针传递内存地址总是一个最快速的选择。
