# 各种文件功能

C++项目中一般会出现以下几种文件，大部分可以通过文件名后缀来识别。

- `.h`或者`.hpp`，头文件，用于放置各种声明，包括类型声明、函数声明、类声明等，但是最好不要将实现代码放在这里。
- `.c`或者`.cpp`，源代码文件，用于放置同名`.hpp`文件声明内容的定义，需要使用`#include`将同名头文件包含进来从而与其建立关联。如果使用了其他头文件中声明的功能，只需要将保存有相应功能声明的头文件包含进来即可。
- `makefile`，项目构建配置文件，用于定义项目中全部源码的编译过程。
- `CMakeLists.txt`，跨平台的编译配置，比`makefile`更加方便易用，可以使用`cmake`命令将其转化为`makefile`文件，使编译配置工作简化。
- `.dll`和`.so`，动态链接库文件，作为程序的外部功能支持库使用。其中`.dll`用于 Windows 系统，`.so`用于 Unix 系统。
- `.o`和`.obj`，编译目标文件，由源码直接编译得来，未经过组合的原始二进制文件。分别用于 Unix 和 Windows 系统。
- `.a`和`.lib`，静态链接库文件，由`.o`和`.obj`组合而来。分别用于 Unix 和 Windows 系统。
