# 字符串

C++中的字符串有两种风格，第一种称为 C 风格字符串，另一种为`string`类。

## C 风格字符串

其表现形式为一个字符数组，数组的末尾元素为`\0`（`null`值）用来标记字符串的结束。例如以下两个字符串是等价的。

```c++
char greeting[] = {'H', 'e', 'l', 'l', 'o', '\0'};
char greeting[] = "Hello";
```

在使用 C 风格字符串时，不需要手动将`\0`放置在字符串的末尾，C++会自动完成这个操作。

C++在标准库的`cstring`模块中提供了大量的用于操作 C 风格字符串的函数，具体使用时可以查询标准库的相应模块。

## `string`类

C++中添加了一个`string`类来完成字符串的相关操作。`string`类位于标准库中，在使用时需要使用`#include <string>`将其包含进来，使用方法可见一下示例。

```c++
#include <string>

int main() {
    std::string str1 = "Hello";
}
```

如果不打算使用`std::string`的形式，可以使用`using namespace std;`来声明当前文件使用`std`命名空间，即可使用`sting str1`的变量声明格式。

`string`类中定义了一系列的常用字符串操作，并对一些操作符进行了重载，具体使用时可以参考标准库的说明。
